"""
    Ubiquity REST API

    Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar  #### Testnet Testnet support coming soon  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.   # noqa: E501

    The version of the OpenAPI document: 2.0.0
    Contact: support@blockdaemon.com
    Generated by: https://openapi-generator.tech
"""

import unittest

import httpretty

import test.mock
import test.utils
from ubiquity import Configuration
from ubiquity.api import (
    protocol_and_endpoint_support_api,
    ApiClient,
)


class TestProtocolsApi(unittest.TestCase):
    """ProtocolsApi unit test stubs"""
    def setUp(self):
        self.api_client = ApiClient(Configuration())
        self.api_instance = protocol_and_endpoint_support_api.ProtocolAndEndpointSupportApi(
            self.api_client)  # noqa: E501
        self.protocols = test.utils.get_protocols()

        network = "mainnet"

        self.get_protocol_endpoints = [{
            "req_url":
            f"/{protocol}/{network}",
            "method":
            httpretty.GET,
            "status":
            200,
            "response_data":
            test.mock.get_mock_file_content(
                f'protocols_api/protocol_algorand.json')
        } for protocol in self.protocols]

    def tearDown(self):
        pass

    @httpretty.activate(verbose=True, allow_net_connect=False)
    def test_get_protocol(self):
        network = "mainnet"
        test.mock.setup_mock_server(self.api_client.configuration.host, self.get_protocol_endpoints)

        for protocol in self.protocols:
            try:
                _ = self.api_instance.get_protocol_endpoints(protocol, network)
            except Exception as e:
                raise e

    @httpretty.activate(verbose=True, allow_net_connect=False)
    def test_protocols_overview(self):
        test.mock.setup_mock_server(self.api_client.configuration.host, [{
            "req_url":
            f"/",
            "method":
            httpretty.GET,
            "status":
            200,
            "response_data":
            test.mock.get_mock_file_content(
                f'protocols_api/protocol_overview.json')
        }])

        try:
            _ = self.api_instance.get_protocols_list()
        except Exception as e:
            raise e


if __name__ == '__main__':
    unittest.main()
